Index: trunk/options/SPECIES/SPECIES_017
===================================================================
--- trunk/options/SPECIES/SPECIES_017	(revision 20)
+++ trunk/options/SPECIES/SPECIES_017	(revision 24)
@@ -9,4 +9,8 @@
  1.0E-04           Wet deposition - A
 0.80               Wet deposition - B
+2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
+0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
+0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: trunk/options/SPECIES/SPECIES_018
===================================================================
--- trunk/options/SPECIES/SPECIES_018	(revision 20)
+++ trunk/options/SPECIES/SPECIES_018	(revision 24)
@@ -9,4 +9,8 @@
  1.0E-04           Wet deposition - A
 0.80               Wet deposition - B
+2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
+0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
+0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: trunk/options/SPECIES/SPECIES_019
===================================================================
--- trunk/options/SPECIES/SPECIES_019	(revision 20)
+++ trunk/options/SPECIES/SPECIES_019	(revision 24)
@@ -9,4 +9,8 @@
 -9.9E-09           Wet deposition - A
                    Wet deposition - B
+-9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
+-9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
+-9.9               In-cloud scavenging - Ci (S_i=Ci/cl)
+-9.9               In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: trunk/options/SPECIES/SPECIES_020
===================================================================
--- trunk/options/SPECIES/SPECIES_020	(revision 20)
+++ trunk/options/SPECIES/SPECIES_020	(revision 24)
@@ -9,4 +9,8 @@
  1.0E-04           Wet deposition - A
 0.80               Wet deposition - B
+2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
+0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
+0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: trunk/options/SPECIES/SPECIES_021
===================================================================
--- trunk/options/SPECIES/SPECIES_021	(revision 20)
+++ trunk/options/SPECIES/SPECIES_021	(revision 24)
@@ -6,7 +6,11 @@
 ****************************************************************************
 Xe-133             Tracer name
-198720.0           Species half life
+453168.0           Species half life
 -9.9E-09           Wet deposition - A
                    Wet deposition - B
+-9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
+-9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
+-9.9               In-cloud scavenging - Ci (S_i=Ci/cl)
+-9.9               In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: trunk/options/SPECIES/SPECIES_022
===================================================================
--- trunk/options/SPECIES/SPECIES_022	(revision 20)
+++ trunk/options/SPECIES/SPECIES_022	(revision 24)
@@ -9,4 +9,8 @@
 -9.9E-09           Wet deposition - A
                    Wet deposition - B
+-9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
+-9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
+-9.9               In-cloud scavenging - Ci (S_i=Ci/cl)
+-9.9               In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: trunk/options/SPECIES/SPECIES_024
===================================================================
--- trunk/options/SPECIES/SPECIES_024	(revision 20)
+++ trunk/options/SPECIES/SPECIES_024	(revision 24)
@@ -9,4 +9,8 @@
 -9.9E-09           Wet deposition - A
                    Wet deposition - B
+-9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
+-9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
+-9.9               In-cloud scavenging - Ci (S_i=Ci/cl)
+-9.9               In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: trunk/options/SPECIES/SPECIES_025
===================================================================
--- trunk/options/SPECIES/SPECIES_025	(revision 20)
+++ trunk/options/SPECIES/SPECIES_025	(revision 24)
@@ -9,4 +9,8 @@
 2.0E-05            Wet deposition - A
 0.8                Wet deposition - B
+2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
+0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
+0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: trunk/src/FLEXPART.f90
===================================================================
--- trunk/src/FLEXPART.f90	(revision 20)
+++ trunk/src/FLEXPART.f90	(revision 24)
@@ -61,5 +61,5 @@
 
   ! 
-  flexversion='Version 9.1.8  (2013-12-08)'
+  flexversion='Version 9.2 beta (2014-05-23)'
   !verbosity=0
   ! Read the pathnames where input/output files are stored
@@ -111,5 +111,5 @@
   ! Print the GPL License statement
   !*******************************************************
-  print*,'Welcome to FLEXPART', trim(flexversion)
+  print*,'Welcome to FLEXPART ', trim(flexversion)
   print*,'FLEXPART is free software released under the GNU Genera'// &
        'l Public License.'
Index: trunk/src/calcpv.f90
===================================================================
--- trunk/src/calcpv.f90	(revision 20)
+++ trunk/src/calcpv.f90	(revision 24)
@@ -21,5 +21,5 @@
 
 subroutine calcpv(n,uuh,vvh,pvh)
-  !                  i  i   i   o
+  !               i  i   i   o
   !*****************************************************************************
   !                                                                            *
@@ -49,6 +49,6 @@
   integer :: nlck
   real :: vx(2),uy(2),phi,tanphi,cosphi,dvdx,dudy,f
-  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt,ppmk
-  real :: pvavr,ppml(nuvzmax)
+  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt
+  real :: pvavr,ppml(0:nxmax-1,0:nymax-1,nuvzmax),ppmk(0:nxmax-1,0:nymax-1,nuvzmax)
   real :: thup,thdn
   real,parameter :: eps=1.e-5, p0=101325
@@ -62,4 +62,13 @@
   ! Loop over entire grid
   !**********************
+  do kl=1,nuvz
+    do jy=0,nymin1
+      do ix=0,nxmin1
+         ppml(ix,jy,kl)=akz(kl)+bkz(kl)*ps(ix,jy,1,n)
+      enddo
+    enddo
+  enddo
+  ppmk=(100000./ppml)**kappa
+
   do jy=0,nymin1
     if (sglobal.and.jy.eq.0) goto 10
@@ -106,8 +115,4 @@
       end if
       jux=jumpx
-  ! Precalculate pressure values for efficiency
-      do kl=1,nuvz
-        ppml(kl)=akz(kl)+bkz(kl)*ps(ix,jy,1,n)
-      end do
   !
   ! Loop over the vertical
@@ -115,6 +120,5 @@
 
       do kl=1,nuvz
-        ppmk=akz(kl)+bkz(kl)*ps(ix,jy,1,n)
-        theta=tth(ix,jy,kl,n)*(100000./ppmk)**kappa
+        theta=tth(ix,jy,kl,n)*ppmk(ix,jy,kl)
         klvrp=kl+1
         klvrm=kl-1
@@ -125,9 +129,7 @@
         if (klvrp.gt.nuvz) klvrp=nuvz
         if (klvrm.lt.1) klvrm=1
-        ppmk=akz(klvrp)+bkz(klvrp)*ps(ix,jy,1,n)
-        thetap=tth(ix,jy,klvrp,n)*(100000./ppmk)**kappa
-        ppmk=akz(klvrm)+bkz(klvrm)*ps(ix,jy,1,n)
-        thetam=tth(ix,jy,klvrm,n)*(100000./ppmk)**kappa
-        dthetadp=(thetap-thetam)/(ppml(klvrp)-ppml(klvrm))
+        thetap=tth(ix,jy,klvrp,n)*ppmk(ix,jy,klvrp)
+        thetam=tth(ix,jy,klvrm,n)*ppmk(ix,jy,klvrm)
+        dthetadp=(thetap-thetam)/(ppml(ix,jy,klvrp)-ppml(ix,jy,klvrm))
 
   ! Compute vertical position at pot. temperature surface on subgrid
@@ -156,23 +158,21 @@
           kch=kch+1
           k=kup
-          ppmk=akz(k)+bkz(k)*ps(ivr,jy,1,n)
-          thdn=tth(ivr,jy,k,n)*(100000./ppmk)**kappa
-          ppmk=akz(k+1)+bkz(k+1)*ps(ivr,jy,1,n)
-          thup=tth(ivr,jy,k+1,n)*(100000./ppmk)**kappa
-
-
-      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
-           ((thdn.le.theta).and.(thup.ge.theta))) then
-              dt1=abs(theta-thdn)
-              dt2=abs(theta-thup)
-              dt=dt1+dt2
-              if (dt.lt.eps) then   ! Avoid division by zero error
-                dt1=0.5             ! G.W., 10.4.1996
-                dt2=0.5
-                dt=1.0
-              endif
-          vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
-              goto 20
+          thdn=tth(ivr,jy,k,n)*ppmk(ivr,jy,k)
+          thup=tth(ivr,jy,k+1,n)*ppmk(ivr,jy,k+1)
+
+
+          if (((thdn.ge.theta).and.(thup.le.theta)).or. &
+          ((thdn.le.theta).and.(thup.ge.theta))) then
+            dt1=abs(theta-thdn)
+            dt2=abs(theta-thup)
+            dt=dt1+dt2
+            if (dt.lt.eps) then   ! Avoid division by zero error
+              dt1=0.5             ! G.W., 10.4.1996
+              dt2=0.5
+              dt=1.0
             endif
+            vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
+            goto 20
+          endif
 41        continue
   ! Downward branch
@@ -181,23 +181,21 @@
           kch=kch+1
           k=kdn
-          ppmk=akz(k)+bkz(k)*ps(ivr,jy,1,n)
-          thdn=tth(ivr,jy,k,n)*(100000./ppmk)**kappa
-          ppmk=akz(k+1)+bkz(k+1)*ps(ivr,jy,1,n)
-          thup=tth(ivr,jy,k+1,n)*(100000./ppmk)**kappa
-
-      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
-           ((thdn.le.theta).and.(thup.ge.theta))) then
-              dt1=abs(theta-thdn)
-              dt2=abs(theta-thup)
-              dt=dt1+dt2
-              if (dt.lt.eps) then   ! Avoid division by zero error
-                dt1=0.5             ! G.W., 10.4.1996
-                dt2=0.5
-                dt=1.0
-              endif
-          vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
-              goto 20
+          thdn=tth(ivr,jy,k,n)*ppmk(ivr,jy,k)
+          thup=tth(ivr,jy,k+1,n)*ppmk(ivr,jy,k+1)
+
+          if (((thdn.ge.theta).and.(thup.le.theta)).or. &
+          ((thdn.le.theta).and.(thup.ge.theta))) then
+            dt1=abs(theta-thdn)
+            dt2=abs(theta-thup)
+            dt=dt1+dt2
+            if (dt.lt.eps) then   ! Avoid division by zero error
+              dt1=0.5             ! G.W., 10.4.1996
+              dt2=0.5
+              dt=1.0
             endif
-            goto 40
+            vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
+            goto 20
+          endif
+          goto 40
   ! This section used when no values were found
 21      continue
@@ -236,21 +234,19 @@
           kch=kch+1
           k=kup
-          ppmk=akz(k)+bkz(k)*ps(ix,j,1,n)
-          thdn=tth(ix,j,k,n)*(100000./ppmk)**kappa
-          ppmk=akz(k+1)+bkz(k+1)*ps(ix,j,1,n)
-          thup=tth(ix,j,k+1,n)*(100000./ppmk)**kappa
-      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
-           ((thdn.le.theta).and.(thup.ge.theta))) then
-              dt1=abs(theta-thdn)
-              dt2=abs(theta-thup)
-              dt=dt1+dt2
-              if (dt.lt.eps) then   ! Avoid division by zero error
-                dt1=0.5             ! G.W., 10.4.1996
-                dt2=0.5
-                dt=1.0
-              endif
-              uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
-              goto 50
+          thdn=tth(ix,j,k,n)*ppmk(ix,j,k)
+          thup=tth(ix,j,k+1,n)*ppmk(ix,j,k+1)
+          if (((thdn.ge.theta).and.(thup.le.theta)).or. &
+          ((thdn.le.theta).and.(thup.ge.theta))) then
+            dt1=abs(theta-thdn)
+            dt2=abs(theta-thup)
+            dt=dt1+dt2
+            if (dt.lt.eps) then   ! Avoid division by zero error
+              dt1=0.5             ! G.W., 10.4.1996
+              dt2=0.5
+              dt=1.0
             endif
+            uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
+            goto 50
+          endif
 71        continue
   ! Downward branch
@@ -259,27 +255,25 @@
           kch=kch+1
           k=kdn
-          ppmk=akz(k)+bkz(k)*ps(ix,j,1,n)
-          thdn=tth(ix,j,k,n)*(100000./ppmk)**kappa
-          ppmk=akz(k+1)+bkz(k+1)*ps(ix,j,1,n)
-          thup=tth(ix,j,k+1,n)*(100000./ppmk)**kappa
-      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
-           ((thdn.le.theta).and.(thup.ge.theta))) then
-              dt1=abs(theta-thdn)
-              dt2=abs(theta-thup)
-              dt=dt1+dt2
-              if (dt.lt.eps) then   ! Avoid division by zero error
-                dt1=0.5             ! G.W., 10.4.1996
-                dt2=0.5
-                dt=1.0
-              endif
-              uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
-              goto 50
+          thdn=tth(ix,j,k,n)*ppmk(ix,j,k)
+          thup=tth(ix,j,k+1,n)*ppmk(ix,j,k+1)
+          if (((thdn.ge.theta).and.(thup.le.theta)).or. &
+          ((thdn.le.theta).and.(thup.ge.theta))) then
+            dt1=abs(theta-thdn)
+            dt2=abs(theta-thup)
+            dt=dt1+dt2
+            if (dt.lt.eps) then   ! Avoid division by zero error
+              dt1=0.5             ! G.W., 10.4.1996
+              dt2=0.5
+              dt=1.0
             endif
-            goto 70
+            uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
+            goto 50
+          endif
+          goto 70
   ! This section used when no values were found
 51      continue
   ! Must use uu at current level and lat. juy becomes smaller by 1
-        uy(jj)=uuh(ix,jy,kl)
-        juy=juy-1
+          uy(jj)=uuh(ix,jy,kl)
+          juy=juy-1
   ! Otherwise OK
 50        continue
Index: trunk/src/calcpv_nests.f90
===================================================================
--- trunk/src/calcpv_nests.f90	(revision 20)
+++ trunk/src/calcpv_nests.f90	(revision 24)
@@ -21,5 +21,5 @@
 
 subroutine calcpv_nests(l,n,uuhn,vvhn,pvhn)
-  !                        i i  i    i    o
+  !                     i i  i    i    o
   !*****************************************************************************
   !                                                                            *
@@ -48,6 +48,6 @@
   integer :: nlck,l
   real :: vx(2),uy(2),phi,tanphi,cosphi,dvdx,dudy,f
-  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt,ppmk
-  real :: ppml(nuvzmax)
+  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt
+  real :: ppml(0:nxmaxn-1,0:nymaxn-1,nuvzmax),ppmk(0:nxmaxn-1,0:nymaxn-1,nuvzmax)
   real :: thup,thdn
   real,parameter :: eps=1.e-5,p0=101325
@@ -61,4 +61,13 @@
   ! Loop over entire grid
   !**********************
+  do kl=1,nuvz
+    do jy=0,nyn(l)-1
+      do ix=0,nxn(l)-1
+         ppml(ix,jy,kl)=akz(kl)+bkz(kl)*psn(ix,jy,1,n,l)
+      enddo
+    enddo
+  enddo
+  ppmk=(100000./ppml)**kappa
+
   do jy=0,nyn(l)-1
     phi = (ylat0n(l) + jy * dyn(l)) * pi / 180.
@@ -88,8 +97,4 @@
       if (ix.eq.0.or.ix.eq.nxn(l)-1) jumpx=1
       jux=jumpx
-  ! Precalculate pressure values for efficiency
-      do kl=1,nuvz
-        ppml(kl)=akz(kl)+bkz(kl)*psn(ix,jy,1,n,l)
-      end do
   !
   ! Loop over the vertical
@@ -97,6 +102,5 @@
 
       do kl=1,nuvz
-        ppmk=akz(kl)+bkz(kl)*psn(ix,jy,1,n,l)
-        theta=tthn(ix,jy,kl,n,l)*(100000./ppmk)**kappa
+        theta=tthn(ix,jy,kl,n,l)*ppmk(ix,jy,kl)
         klvrp=kl+1
         klvrm=kl-1
@@ -107,9 +111,7 @@
         if (klvrp.gt.nuvz) klvrp=nuvz
         if (klvrm.lt.1) klvrm=1
-        ppmk=akz(klvrp)+bkz(klvrp)*psn(ix,jy,1,n,l)
-        thetap=tthn(ix,jy,klvrp,n,l)*(100000./ppmk)**kappa
-        ppmk=akz(klvrm)+bkz(klvrm)*psn(ix,jy,1,n,l)
-        thetam=tthn(ix,jy,klvrm,n,l)*(100000./ppmk)**kappa
-        dthetadp=(thetap-thetam)/(ppml(klvrp)-ppml(klvrm))
+        thetap=tthn(ix,jy,klvrp,n,l)*ppmk(ix,jy,klvrp)
+        thetam=tthn(ix,jy,klvrm,n,l)*ppmk(ix,jy,klvrm)
+        dthetadp=(thetap-thetam)/(ppml(ix,jy,klvrp)-ppml(ix,jy,klvrm))
 
   ! Compute vertical position at pot. temperature surface on subgrid
@@ -134,8 +136,6 @@
           kch=kch+1
           k=kup
-          ppmk=akz(k)+bkz(k)*psn(ivr,jy,1,n,l)
-          thdn=tthn(ivr,jy,k,n,l)*(100000./ppmk)**kappa
-          ppmk=akz(k+1)+bkz(k+1)*psn(ivr,jy,1,n,l)
-          thup=tthn(ivr,jy,k+1,n,l)*(100000./ppmk)**kappa
+          thdn=tthn(ivr,jy,k,n,l)*ppmk(ivr,jy,k)
+          thup=tthn(ivr,jy,k+1,n,l)*ppmk(ivr,jy,k+1)
 
       if (((thdn.ge.theta).and.(thup.le.theta)).or. &
@@ -158,8 +158,6 @@
           kch=kch+1
           k=kdn
-          ppmk=akz(k)+bkz(k)*psn(ivr,jy,1,n,l)
-          thdn=tthn(ivr,jy,k,n,l)*(100000./ppmk)**kappa
-          ppmk=akz(k+1)+bkz(k+1)*psn(ivr,jy,1,n,l)
-          thup=tthn(ivr,jy,k+1,n,l)*(100000./ppmk)**kappa
+          thdn=tthn(ivr,jy,k,n,l)*ppmk(ivr,jy,k)
+          thup=tthn(ivr,jy,k+1,n,l)*ppmk(ivr,jy,k+1)
       if (((thdn.ge.theta).and.(thup.le.theta)).or. &
            ((thdn.le.theta).and.(thup.ge.theta))) then
@@ -212,8 +210,6 @@
           kch=kch+1
           k=kup
-          ppmk=akz(k)+bkz(k)*psn(ix,j,1,n,l)
-          thdn=tthn(ix,j,k,n,l)*(100000./ppmk)**kappa
-          ppmk=akz(k+1)+bkz(k+1)*psn(ix,j,1,n,l)
-          thup=tthn(ix,j,k+1,n,l)*(100000./ppmk)**kappa
+          thdn=tthn(ix,j,k,n,l)*ppmk(ix,j,k)
+          thup=tthn(ix,j,k+1,n,l)*ppmk(ix,j,k+1)
       if (((thdn.ge.theta).and.(thup.le.theta)).or. &
            ((thdn.le.theta).and.(thup.ge.theta))) then
@@ -235,8 +231,6 @@
           kch=kch+1
           k=kdn
-          ppmk=akz(k)+bkz(k)*psn(ix,j,1,n,l)
-          thdn=tthn(ix,j,k,n,l)*(100000./ppmk)**kappa
-          ppmk=akz(k+1)+bkz(k+1)*psn(ix,j,1,n,l)
-          thup=tthn(ix,j,k+1,n,l)*(100000./ppmk)**kappa
+          thdn=tthn(ix,j,k,n,l)*ppmk(ix,j,k)
+          thup=tthn(ix,j,k+1,n,l)*ppmk(ix,j,k+1)
       if (((thdn.ge.theta).and.(thup.le.theta)).or. &
            ((thdn.le.theta).and.(thup.ge.theta))) then
Index: trunk/src/com_mod.f90
===================================================================
--- trunk/src/com_mod.f90	(revision 20)
+++ trunk/src/com_mod.f90	(revision 24)
@@ -340,9 +340,6 @@
   real :: qvh(0:nxmax-1,0:nymax-1,nuvzmax,2)
   real :: pplev(0:nxmax-1,0:nymax-1,nuvzmax,2)
-  !scavenging NIK, PS
   integer(kind=1) :: clouds(0:nxmax-1,0:nymax-1,nzmax,2)
   integer :: cloudsh(0:nxmax-1,0:nymax-1,2)
-      integer icloudbot(0:nxmax-1,0:nymax-1,2)
-      integer icloudthck(0:nxmax-1,0:nymax-1,2)
 
 
@@ -359,7 +356,4 @@
   !      rainout  conv/lsp dominated  2/3
   !      washout  conv/lsp dominated  4/5
-! PS 2013
-!c icloudbot (m)        cloud bottom height
-!c icloudthck (m)       cloud thickness     
 
   ! pplev for the GFS version
Index: trunk/src/gridcheck.f90
===================================================================
--- trunk/src/gridcheck.f90	(revision 20)
+++ trunk/src/gridcheck.f90	(revision 24)
@@ -84,8 +84,8 @@
   real(kind=4) :: xaux1,xaux2,yaux1,yaux2
   real(kind=8) :: xaux1in,xaux2in,yaux1in,yaux2in
-  integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl
+  integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl,parID
   !HSO  end
   integer :: ix,jy,i,ifn,ifield,j,k,iumax,iwmax,numskip
-  real :: sizesouth,sizenorth,xauxa,pint
+  real :: sizesouth,sizenorth,xauxa,pint,conversion_factor
 
   ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING
@@ -98,6 +98,5 @@
 
   integer :: isec1(56),isec2(22+nxmax+nymax)
-  !real(kind=4) :: zsec2(60+2*nuvzmax),zsec4(jpunp)
-  real(kind=4) :: zsec2(184),zsec4(jpunp)
+  real(kind=4) :: zsec2(60+2*nuvzmax),zsec4(jpunp)
   character(len=1) :: opt
 
@@ -172,4 +171,6 @@
   call grib_check(iret,gribFunction,gribErrorMsg)
   call grib_get_int(igrib,'level',valSurf,iret)
+  call grib_check(iret,gribFunction,gribErrorMsg)
+  call grib_get_int(igrib,'paramId',parId,iret)
   call grib_check(iret,gribFunction,gribErrorMsg)
 
@@ -193,4 +194,6 @@
   elseif ((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
     isec1(6)=135         ! indicatorOfParameter
+  elseif ((parCat.eq.128).and.(parNum.eq.77)) then ! W, actually eta dot
+    isec1(6)=135         ! indicatorOfParameter
   elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101)) then !SLP
     isec1(6)=151         ! indicatorOfParameter
@@ -205,7 +208,7 @@
   elseif ((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SD
     isec1(6)=141         ! indicatorOfParameter
-  elseif ((parCat.eq.6).and.(parNum.eq.1)) then ! CC
+  elseif ((parCat.eq.6).and.(parNum.eq.1) .or. parId .eq. 164) then ! CC
     isec1(6)=164         ! indicatorOfParameter
-  elseif ((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
+  elseif ((parCat.eq.1).and.(parNum.eq.9) .or. parId .eq. 142) then ! LSP
     isec1(6)=142         ! indicatorOfParameter
   elseif ((parCat.eq.1).and.(parNum.eq.10)) then ! CP
@@ -215,11 +218,11 @@
   elseif ((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1)) then ! SR
     isec1(6)=176         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.17)) then ! EWSS
+  elseif ((parCat.eq.2).and.(parNum.eq.17) .or. parId .eq. 180) then ! EWSS
     isec1(6)=180         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.18)) then ! NSSS
+  elseif ((parCat.eq.2).and.(parNum.eq.18) .or. parId .eq. 181) then ! NSSS
     isec1(6)=181         ! indicatorOfParameter
   elseif ((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
     isec1(6)=129         ! indicatorOfParameter
-  elseif ((parCat.eq.3).and.(parNum.eq.7)) then ! SDO
+  elseif ((parCat.eq.3).and.(parNum.eq.7) .or. parId .eq. 160) then ! SDO
     isec1(6)=160         ! indicatorOfParameter
   elseif ((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and. &
@@ -230,4 +233,8 @@
          parCat,parNum,typSurf
   endif
+  if(parId .ne. isec1(6) .and. parId .ne. 77) then
+    write(*,*) 'parId',parId, 'isec1(6)',isec1(6)
+!    stop
+  endif
 
   endif
@@ -265,5 +272,5 @@
 
   !HSO  get the second part of the grid dimensions only from GRiB1 messages
-  if ((gribVer.eq.1).and.(gotGrid.eq.0)) then
+  if (isec1(6) .eq. 167 .and. (gotGrid.eq.0)) then
     call grib_get_real8(igrib,'longitudeOfLastGridPointInDegrees', &
          xaux2in,iret)
@@ -291,5 +298,4 @@
     dyconst=180./(dy*r_earth*pi)
     gotGrid=1
-
   ! Check whether fields are global
   ! If they contain the poles, specify polar stereographic map
@@ -443,7 +449,7 @@
   write(*,*)
   write(*,'(a)') 'Mother domain:'
-  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ', &
+  write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Longitude range: ', &
        xlon0,' to ',xlon0+(nx-1)*dx,'   Grid distance: ',dx
-  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range: ', &
+  write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Latitude range: ', &
        ylat0,' to ',ylat0+(ny-1)*dy,'   Grid distance: ',dy
   write(*,*)
@@ -467,4 +473,5 @@
     k=nlev_ec+1+numskip+i
     akm(nwz-i+1)=zsec2(j)
+  !   write (*,*) 'ifield:',ifield,k,j,zsec2(10+j)
     bkm(nwz-i+1)=zsec2(k)
   end do
@@ -553,2 +560,3 @@
 
 end subroutine gridcheck
+
Index: trunk/src/gridcheck_nests.f90
===================================================================
--- trunk/src/gridcheck_nests.f90	(revision 20)
+++ trunk/src/gridcheck_nests.f90	(revision 24)
@@ -48,4 +48,5 @@
   integer :: igrib
   integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl
+  integer :: parID !added by mc for making it consistent with new gridcheck.f90
   integer :: gotGrib
   !HSO  end
@@ -55,4 +56,5 @@
   real(kind=4) :: xaux1,xaux2,yaux1,yaux2
   real(kind=8) :: xaux1in,xaux2in,yaux1in,yaux2in
+  real :: conversion_factor !added by mc to make it consistent with new gridchek.f90
 
   ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING
@@ -150,4 +152,6 @@
   call grib_get_int(igrib,'level',valSurf,iret)
   call grib_check(iret,gribFunction,gribErrorMsg)
+  call grib_get_int(igrib,'paramId',parId,iret) !added by mc to make it consisitent with new grid_check.f90
+  call grib_check(iret,gribFunction,gribErrorMsg) !added by mc to make it consisitent with new  grid_check.f90
 
   !print*,discipl,parCat,parNum,typSurf,valSurf
@@ -170,4 +174,6 @@
   elseif ((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
     isec1(6)=135         ! indicatorOfParameter
+  elseif ((parCat.eq.128).and.(parNum.eq.77)) then ! W, actually eta dot !added bymc to make it consistent with new gridchek.f90
+    isec1(6)=135         ! indicatorOfParameter    !                     ! " " " " " " " " " " " " " " " " " " " " " " " "  " " " 
   elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101)) then !SLP
     isec1(6)=151         ! indicatorOfParameter
@@ -182,7 +188,7 @@
   elseif ((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SD
     isec1(6)=141         ! indicatorOfParameter
-  elseif ((parCat.eq.6).and.(parNum.eq.1)) then ! CC
+  elseif ((parCat.eq.6).and.(parNum.eq.1) .or. parId .eq. 164) then ! CC !added by mc to make it consistent with new gridchek.f90
     isec1(6)=164         ! indicatorOfParameter
-  elseif ((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
+ elseif ((parCat.eq.1).and.(parNum.eq.9) .or. parId .eq. 142) then ! LSP !added by mc to make it consistent with new gridchek.f90
     isec1(6)=142         ! indicatorOfParameter
   elseif ((parCat.eq.1).and.(parNum.eq.10)) then ! CP
@@ -192,11 +198,11 @@
   elseif ((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1)) then ! SR
     isec1(6)=176         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.17)) then ! EWSS
+  elseif ((parCat.eq.2).and.(parNum.eq.17) .or. parId .eq. 180) then ! EWSS !added by mc to make it consistent with new gridchek.f90
     isec1(6)=180         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.18)) then ! NSSS
+  elseif ((parCat.eq.2).and.(parNum.eq.18) .or. parId .eq. 181) then ! NSSS !added by mc to make it consistent with new gridchek.f90
     isec1(6)=181         ! indicatorOfParameter
   elseif ((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
     isec1(6)=129         ! indicatorOfParameter
-  elseif ((parCat.eq.3).and.(parNum.eq.7)) then ! SDO
+  elseif ((parCat.eq.3).and.(parNum.eq.7) .or. parId .eq. 160) then ! SDO !added by mc to make it consistent with new gridchek.f90
     isec1(6)=160         ! indicatorOfParameter
   elseif ((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and. &
@@ -207,4 +213,8 @@
          parCat,parNum,typSurf
   endif
+  if(parId .ne. isec1(6) .and. parId .ne. 77) then !added by mc to make it consistent with new gridchek.f90
+    write(*,*) 'parId',parId, 'isec1(6)',isec1(6)
+!    stop
+  endif
 
   endif
@@ -237,6 +247,6 @@
 
   !HSO  get the second part of the grid dimensions only from GRiB1 messages
-  if ((gribVer.eq.1).and.(gotGrib.eq.0)) then
-    call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', &
+  if (isec1(6) .eq. 167 .and. (gotGrib.eq.0)) then !added by mc to make it consistent with new gridchek.f90 note that gotGrid must be changed in gotGrib!!
+    call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', & !comment by mc: note that this was in the (if (ifield.eq.1) ..end above in gridchek.f90 see line 257
          xaux1in,iret)
     call grib_check(iret,gribFunction,gribErrorMsg)
@@ -254,14 +264,14 @@
     yaux1=yaux1in
     yaux2=yaux2in
-    if(xaux1.gt.180) xaux1=xaux1-360.0
-    if(xaux2.gt.180) xaux2=xaux2-360.0
-    if(xaux1.lt.-180) xaux1=xaux1+360.0
-    if(xaux2.lt.-180) xaux2=xaux2+360.0
-    if (xaux2.lt.xaux1) xaux2=xaux2+360.
+    if(xaux1.gt.180.) xaux1=xaux1-360.0
+    if(xaux2.gt.180.) xaux2=xaux2-360.0
+    if(xaux1.lt.-180.) xaux1=xaux1+360.0
+    if(xaux2.lt.-180.) xaux2=xaux2+360.0
+    if (xaux2.lt.xaux1) xaux2=xaux2+360.0
     xlon0n(l)=xaux1
     ylat0n(l)=yaux1
     dxn(l)=(xaux2-xaux1)/real(nxn(l)-1)
     dyn(l)=(yaux2-yaux1)/real(nyn(l)-1)
-    gotGrib=1
+    gotGrib=1 !commetn by mc note tahthere gotGRIB is used instead of gotGrid!!!
   endif ! ifield.eq.1
 
@@ -341,8 +351,8 @@
 
   write(*,'(a,i2)') 'Nested domain #: ',l
-  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ', &
+  write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Longitude range: ', &
        xlon0n(l),' to ',xlon0n(l)+(nxn(l)-1)*dxn(l), &
        '   Grid distance: ',dxn(l)
-  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range: ', &
+  write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Latitude range: ', &
        ylat0n(l),' to ',ylat0n(l)+(nyn(l)-1)*dyn(l), &
        '   Grid distance: ',dyn(l)
